/*
 *  NAME: negexp.c
 *
 *
 *  VERSION: 1.2
 *
 *
 *  COPYRIGHT:                                                        
 *
 *  
 *    (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
 *    (C) COPYRIGHT International Business Machines Corp. 1993, 1997
 *    All Rights Reserved
 *    Licensed Materials - Property of IBM
 *   
 *    US Government Users Restricted Rights - Use, duplication or
 *    disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *  
 *                                                                    
 *
 *
 *  Base level
 *
 *  SYNOPSIS:
 *
 * double negexp(double mean)
 *
 *  DESCRIPTION:
 *
 * Return a sample from a negative exponential distribution
 * with the given mean
 *
 *  CAVEATS/WARNINGS:
 *
 *
 *
 *  RETURNED VALUES:
 *
 *
 *  RELATED INFORMATION:
 *
 *
 */
#include <epiload.h>
#include <epiload_int.h>
#include <stdlib.h>
double negexp ( double mean )
{
   return - mean * log(drand48()) ;
}
