#
# NAME:         db2xa.c
# VERSION:      1.2
# COPYRIGHT:                                                        
# 
#   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
#   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#  
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
# 
#            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
# 
# INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
# EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS"
# WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
# INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
# RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
# BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
# ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
# IBM ) ASSUME 
# THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
#                                                                   
#
#
#  NOTE : This Makefile assumes you have run db2ln - see
#         DATABASE 2 Installation Guide for more details
# 
# This makefile should be run with the command "make -f db2xa.mk"
#

all: db2xa.c
	cc -c -s -I/opt/encina/include db2xa.c \
	-Aa \
	+z \
	-o db2xa.o

	ld -b -o db2xa db2xa.o \
	/opt/cics/lib/regxa_swxa.o \
	+e CICS_XA_Init \
	-L/opt/encina/lib \
	-L/opt/IBMdb2/V2.1/lib \
	-L/opt/cics/lib \
	-lEncina \
	-ldce \
	-ldb2 \
	-lcicsrt
