/*
* NAME:         oraclexa.c
* VERSION:      1.1
* COPYRIGHT:                                                        
* 
*   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
*   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
*   All Rights Reserved
*   Licensed Materials - Property of IBM
*  
*   US Government Users Restricted Rights - Use, duplication or
*   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
* 
* 
*            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
* 
* INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
* EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS"
* WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
* INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
* RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
* BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
* ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
* IBM ) ASSUME 
* THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
*                                                                   
*
* This is the source of an Oracle Version 7 SwitchLoadFile. 
* The routine references the Oracle Version xa switch structure named xaosw.
* 
*/

#include <stdio.h>
#include <tmxa/xa.h>

extern struct xa_switch_t xaosw;
extern struct xa_switch_t RegXA_xa_switch;
extern struct xa_switch_t *cics_xa_switch;

struct xa_switch_t *CICS_XA_Init(void)
{
    cics_xa_switch = &xaosw;

    cics_xa_init();

    return(&RegXA_xa_switch);
}
