#
# NAME:         oraclexa.mk
# VERSION:      1.2
# COPYRIGHT:                                                        
# 
#   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
#   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#  
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
# 
#            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
# 
# INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
# EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS"
# WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
# INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
# RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
# BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
# ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
# IBM ) ASSUME 
# THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
#                                                                   
#

# All of the sample and example makefiles supplied assume that
# you have set up a standard environment, setting CICSPATH etc.


DCE_ROOT=/opt/dcelocal
ENCINA_ROOT=/opt/encina
CICS_ROOT=/opt/cics
SYSTEM_CCFLAGS=-Aa +z
DCE_CCFLAGS=-D_REENTRANT -D_HPUX_SOURCE -Dhpux -I/usr/include/reentrant
ENCINA_CCFLAGS=-I$(ENCINA_ROOT)/include
CICS_CCFLAGS=-I$(CICS_ROOT)/include
USER_CCFLAGS=-D_XPG4 -D_HPUX_SOURCE
CCFLAGS=$(SYSTEM_CCFLAGS) $(SAMPLE_CCFLAGS) $(USER_CCFLAGS)
SYSTEM_LDFLAGS=-Bimmediate -Bnonfatal +s +b$(CICS_ROOT)/lib
ENCINA_LDFLAGS=-L$(ENCINA_ROOT)/lib
DCE_LDFLAGS=-L$(DCE_ROOT)/lib
CICS_LDFLAGS=-L$(CICS_ROOT)/lib
USER_LDFLAGS=
LINKFLAGS=$(SYSTEM_LDFLAGS) $(SAMPLE_LDFLAGS) $(USER_LDFLAGS)
SYSTEM_LDOBJS=/lib/crt0.o
SYSTEM_LDLIBS=-lc
DCE_LDLIBS=-ldce -lndbm -lM -lc_r
ENCINA_LDLIBS=-lEncina
USER_LDLIBS=-l:libclntsh.sl
LDLIBS=$(USER_LDLIBS) $(SAMPLE_LDLIBS) $(SYSTEM_LDLIBS) $(DCE_LDLIBS)
CICSTRAN_ARGS=-e -d

oraclexa : oraclexa.o $(CICS_ROOT)/lib/regxa_swxa.o
	$(LD) -b +e CICS_XA_Init -o oraclexa oraclexa.o $(CICS_ROOT)/lib/regxa_swxa.o $(LINKFLAGS) $(LDLIBS)


oraclexa.o : oraclexa.c
	$(CC) -c $(CCFLAGS) oraclexa.c $(ENCINA_CCFLAGS)
