# 
# NAME:         uxa1_db2cob.mk
# VERSION:      1.1
# COPYRIGHT:                                                        
# 
#   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
#   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#  
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
# 
#            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
# 
# INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
# EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS"
# WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
# INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
# RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
# BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
# ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
# IBM ) ASSUME 
# THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
#                                                                   
# 
# 

all: UXA1M.map uxa1.gnt

UXA1M.map: uxa1_db2cob.bms
	cicsmap uxa1_db2cob.bms

uxa1.gnt: uxa1.ccp
	COBCPY=/opt/cics/include:/opt/IBMdb2/V2.1/include/cobol_mf; \
	export COBCPY; \
	cicstcl -e -d -lCOBOL uxa1.ccp

uxa1.ccp: uxa1.sqb
	db2 connect to cicstest; \
	db2 prep uxa1.sqb; \
	db2 grant execute on package uxa1 to public; \
	mv uxa1.cbl uxa1.ccp
