# NAME: Log and SFS server migrate functions for Encina 1.1
#
#
# VERSION: 1.1
#
#
# COPYRIGHT:                                                        
# 
#   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
#   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#  
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
#                                                                   
#
# SYNOPSIS:
#
#
# DESCRIPTION:
#
#  This file has been added as a placeholder for migrating log
#  and sfs servers to Encina 1.1. It is not complete yet.
#
#  Most of the code is in place for AIX migration.
#
#*/

# =============================================================================
# Please do not remove this comment block, it is required to delimit
# the data which is extracted for automatic document generation
# =============================================================================
# CANNA PRIVATE END



ERZ46206E=188
ERZ46206E_TEXT='"ERZ046206E: The stanza file '%1\$s' does not exist, or cannot be read, or is not executable"'
ERZ46207E=189
ERZ46207E_TEXT='"ERZ046207E: The attribute '%1\$s' for log server '%2\$s' could not be obtained from the stanza file '%3\$s'"'
ERZ46208E=190
ERZ46208E_TEXT='"ERZ046208E: The userid '%1\$s' of server '%2\$s' has no home directory"'
ERZ46209E=191
ERZ46209E_TEXT='"ERZ046209E: Restart file '%1\$s' for server '%2\$s' does not exist, is empty or is not readable"'
ERZ46210E=192
ERZ46210E_TEXT='"ERZ046210E: Subsystem '%1\$s' does not exist"'
ERZ46211E=193
ERZ46211E_TEXT='"ERZ046211E: CICS was unable to change the entry for subsystem '%1\$s'"'
ERZ46212I=194
ERZ46212I_TEXT='"ERZ046212I: Starting clserver '%1\$s'"'
ERZ46213E=195
ERZ46213E_TEXT='"ERZ046213E: Start of clserver '%1\$s' failed"'
ERZ46214I=196
ERZ46214I_TEXT='"ERZ046214I: Waiting for clserver '%1\$s' to initialize"'
ERZ46215I=197
ERZ46215I_TEXT='"ERZ046215I: Stopping clserver '%1\$s'"'
ERZ46216I=198
ERZ46216I_TEXT='"ERZ046216I: Clserver '%1\$s' started successfully"'
ERZ46217I=199
ERZ46217I_TEXT='"ERZ046217I: Dumping logfile for SFS server '%1\$s'"'
ERZ46218I=200
ERZ46218I_TEXT='"ERZ046218I: Logfile for SFS server '%1\$s' has already been dumped"'
ERZ46219E=201
ERZ46219E_TEXT='"ERZ046219E: SFS Server '%1\$s' not found in stanza file '%2\$s'"'
ERZ46220E=202
ERZ46220E_TEXT='"ERZ046220E: The attribute '%1\$s' for SFS server '%2\$s' could not be obtained from the stanza file '%3\$s'"'
ERZ46221E=203
ERZ46221E_TEXT='"ERZ046221E: Home directory '%1\$s' for user '%2\$s' does not have read, write and execute permission"'
ERZ46222E=204
ERZ46222E_TEXT='"ERZ046222E: CICS cannot start clserver '%1\$s' to migrate SFS server '%2\$s'"'
ERZ46223E=205
ERZ46223E_TEXT='"ERZ046223E: Dump of logfile to file '%1\$s' for SFS server '%2\$s' failed.  See '%3\$s'."'
ERZ46224I=206
ERZ46224I_TEXT='"ERZ046224I: Restoring logfile for SFS server '%1\$s'"'
ERZ46225I=207
ERZ46225I_TEXT='"ERZ046225I: Logfile for SFS server '%1\$s' already restored"'
ERZ46226E=208
ERZ46226E_TEXT='"ERZ046226E: Dump or restart file for server '%1\$s' does not exist"'
ERZ46227E=209
ERZ46227E_TEXT='"ERZ046227E: Archive directory '%1\$s' for server '%2\$s' could not be created"'
ERZ46228I=210
ERZ46228I_TEXT='"ERZ046228I: Starting volume server to restore logfile for server '%1\$s'"'
ERZ46229E=211
ERZ46229E_TEXT='"ERZ046229E: CICS is unable to generate a name for the volume server"'
ERZ46230E=212
ERZ46230E_TEXT='"ERZ046230E: CICS is unable to start the volume server.  See '%1\$s'."'
ERZ46231E=213
ERZ46231E_TEXT='"ERZ046231E: An error occurred in mapping logical volume '%1\$s'.  See '%2\$s'."'
ERZ46233E=215
ERZ46233E_TEXT='"ERZ046233E: An error occurred while restoring the logfile for server '%1\$s'.  See '%2\$s'."'
ERZ46234I=216
ERZ46234I_TEXT='"ERZ046234I: Logfile successfully restored for server '%1\$s'"'
ERZ46235I=217
ERZ46235I_TEXT='"ERZ046235I: Converting log data for CICS region '%1\$s'"'
ERZ46236E=218
ERZ46236E_TEXT='"ERZ046236E: The attribute '%1\$s' for region '%2\$s' could not be obtained from the stanza file '%3\$s'"'
ERZ46237E=219
ERZ46237E_TEXT='"ERZ046237E: CICS cannot start clserver '%1\$s' to migrate region '%2\$s'"'
ERZ46238I=220
ERZ46238I_TEXT='"ERZ046238I: Starting logfile conversion stage 1 for region '%1\$s'"'
ERZ46239I=221
ERZ46239I_TEXT='"ERZ046239I: Starting logfile conversion stage 2 for region '%1\$s'"'
ERZ46240I=222
ERZ46240I_TEXT='"ERZ046240I: Logfile for region '%1\$s' successfully converted"'
ERZ46241E=223
ERZ46241E_TEXT='"ERZ046241E: Logfile conversion stage 2 for region '%1\$s' failed, reason: '%2\$s'"'
ERZ46242E=224
ERZ46242E_TEXT='"ERZ046242E: Logfile conversion stage 1 for region '%1\$s' failed, reason: '%2\$s'"'
ERZ46243I=225
ERZ46243I_TEXT='"ERZ046243I: No SFS servers to migrate"'
ERZ46244I=226
ERZ46244I_TEXT='"ERZ046244I: Starting migration of SFS server '%1\$s'"'
ERZ46245E=227
ERZ46245E_TEXT='"ERZ046245E: Migration of SFS server '%1\$s' failed"'
ERZ46246I=228
ERZ46246I_TEXT='"ERZ046246I: Migration of SFS server '%1\$s' successfully completed"'
ERZ46247I=229
ERZ46247I_TEXT='"ERZ046247I: Dump of logfile data for SFS server '%1\$s' successful"'
ERZ46248W=230
ERZ46248W_TEXT='"ERZ046248W: Restart files exist, the logfile for server '%1\$s' has previously been dumped"'
ERZ46253E=235
ERZ46253E_TEXT='"ERZ046253E: Unable to execute '%1\$s'"'
ERZ46254E=236
ERZ46254E_TEXT='"ERZ046254E: clserver '%1\$s' failed to initialize"'

#
# Module what string
#
#@(#)regrm,22:09:03,Apr 08 1998,s211-L980223
#

MSN_START=98

typeset -r REGRM_MSNX_1=${MSN_START}01
typeset -r REGRM_MSNX_2=${MSN_START}02
typeset -r REGRM_MSNX_3=${MSN_START}03
typeset -r REGRM_MSNX_4=${MSN_START}04
typeset -r REGRM_MSNX_5=${MSN_START}05
typeset -r REGRM_MSNX_6=${MSN_START}06
typeset -r REGRM_MSNX_7=${MSN_START}07
typeset -r REGRM_MSNX_8=${MSN_START}08
typeset -r REGRM_MSNX_9=${MSN_START}09
typeset -r REGRM_MSNX_10=${MSN_START}10
typeset -r REGRM_MSNX_11=${MSN_START}11
typeset -r REGRM_MSNX_12=${MSN_START}12
typeset -r REGRM_MSNX_13=${MSN_START}13
typeset -r REGRM_MSNX_14=${MSN_START}14
typeset -r REGRM_MSNX_15=${MSN_START}15
typeset -r REGRM_MSNX_16=${MSN_START}16
typeset -r REGRM_MSNX_17=${MSN_START}17
typeset -r REGRM_MSNX_18=${MSN_START}18
typeset -r REGRM_MSNX_19=${MSN_START}19
typeset -r REGRM_MSNX_20=${MSN_START}20
typeset -r REGRM_MSNX_21=${MSN_START}21
typeset -r REGRM_MSNX_22=${MSN_START}22
typeset -r REGRM_MSNX_23=${MSN_START}23
typeset -r REGRM_MSNX_24=${MSN_START}24
typeset -r REGRM_MSNX_25=${MSN_START}25
typeset -r REGRM_MSNX_26=${MSN_START}26
typeset -r REGRM_MSNX_27=${MSN_START}27
typeset -r REGRM_MSNX_28=${MSN_START}28
typeset -r REGRM_MSNX_29=${MSN_START}29
typeset -r REGRM_MSNX_30=${MSN_START}30
typeset -r REGRM_MSNX_31=${MSN_START}31
typeset -r REGRM_MSNX_32=${MSN_START}32
typeset -r REGRM_MSNX_33=${MSN_START}33
typeset -r REGRM_MSNX_34=${MSN_START}34
typeset -r REGRM_MSNX_35=${MSN_START}35
typeset -r REGRM_MSNX_36=${MSN_START}36
typeset -r REGRM_MSNX_37=${MSN_START}37
typeset -r REGRM_MSNX_38=${MSN_START}38
typeset -r REGRM_MSNX_39=${MSN_START}39
typeset -r REGRM_MSNX_40=${MSN_START}40
typeset -r REGRM_MSNX_41=${MSN_START}41
typeset -r REGRM_MSNX_42=${MSN_START}42
typeset -r REGRM_MSNX_43=${MSN_START}43
typeset -r REGRM_MSNX_44=${MSN_START}44
typeset -r REGRM_MSNX_45=${MSN_START}45
typeset -r REGRM_MSNX_46=${MSN_START}46
typeset -r REGRM_MSNX_47=${MSN_START}47
typeset -r REGRM_MSNX_48=${MSN_START}48
typeset -r REGRM_MSNX_49=${MSN_START}49
typeset -r REGRM_MSNX_50=${MSN_START}50
typeset -r REGRM_MSNX_51=${MSN_START}51
typeset -r REGRM_MSNX_52=${MSN_START}52
typeset -r REGRM_MSNX_53=${MSN_START}53
typeset -r REGRM_MSNX_54=${MSN_START}54
typeset -r REGRM_MSNX_55=${MSN_START}55
typeset -r REGRM_MSNX_56=${MSN_START}56
typeset -r REGRM_MSNX_57=${MSN_START}57
typeset -r REGRM_MSNX_58=${MSN_START}58
typeset -r REGRM_MSNX_59=${MSN_START}59
typeset -r REGRM_MSNX_60=${MSN_START}60
typeset -r REGRM_MSNX_61=${MSN_START}61
typeset -r REGRM_MSNX_62=${MSN_START}62

#
# cicsmigratelog1 return code meanings
#
typeset RC_ML1[0]="migrated log records successfully written to migration log file"
typeset RC_ML1[1]="incorrect number of parameters passed"
typeset RC_ML1[2]="could not access log directory"
typeset RC_ML1[3]="could not open log migration file (.log.migration)"
typeset RC_ML1[4]="could not write initial control information to migration file"
typeset RC_ML1[5]="Error opening master log on Encina LOG server"
typeset RC_ML1[6]="Error reading restart record from master log on Encina LOG server"
typeset RC_ML1[7]="No restart data exists in master log on Encina LOG server"
typeset RC_ML1[8]="could not write restart data to migration log file"
typeset RC_ML1[9]="Error when opening cursor in master log on Encina LOG server"
typeset RC_ML1[10]="Error when reading cursor in master log on Encina LOG server"
typeset RC_ML1[11]="Start-of-checkpoint record not found at restart, CICS not shutdown cleanly"
typeset RC_ML1[12]="could not write migrated log record header to migration log file"
typeset RC_ML1[13]="could not write migrated log record data to migration log file"
typeset RC_ML1[14]="could not lseek to start of migration log file"
typeset RC_ML1[15]="could not write final control information to migration file"
typeset RC_ML1[16]="could not close migration file"
typeset RC_ML1[17]="Error when closing cursor in master log on Encina LOG server"
typeset RC_ML1[18]="Error when closing master log on Encina LOG server"
typeset RC_ML1[19]="Invalid RPC security level parameter passed"
typeset RC_ML1[20]="Invalid module id - Log is corrupt"

#
# cicsmigratelog2 return code meanings
#
typeset RC_ML2[0]="migrated log records successfully written to new cics log"
typeset RC_ML2[1]="incorrect number of parameters passed"
typeset RC_ML2[2]="could not access log directory"
typeset RC_ML2[3]="could not access log migration file (.log.migration)"
typeset RC_ML2[4]="could not read in control information from migration file"
typeset RC_ML2[5]="data in migration file is invalid"
typeset RC_ML2[6]="could not read in restart record from migration file"
typeset RC_ML2[7]="Failed to initialise new log (DamJO_LogInit())"
typeset RC_ML2[8]="Failed to open new master log"
typeset RC_ML2[9]="could not read log record migration header from migration file"
typeset RC_ML2[10]="could not read log record from migration file"
typeset RC_ML2[11]="Failed to write log record to master log"
typeset RC_ML2[12]="Failed to write restart record to master log"
typeset RC_ML2[13]="Failed to close master log"
typeset RC_ML2[14]="could not delete migration file"

typeset SD_USERID="UserID"
typeset SD_SHORTNAME="ShortName"
typeset SD_LOGSERVER="LogServer"
typeset SD_PROTLEVEL="ProtectionLevel"
typeset SD_LOGFILE="LogFile"
typeset SD_LOGVOLUME="LogFileGroupVolume"
typeset RD_LOGSERVER="LogServer"
typeset RD_CLOGNAME="CLogName"
typeset RD_CARCHNAME="CArchName"
typeset RD_LOGPROTECTION="LogProtection"
typeset SFS_DUMP_FTYPE="dump"
typeset SFS_RESTART1="restart"
typeset ABBREV_HOST="%H"
typeset ABBREV_SHORTNAME="%S"
typeset ABBREV_REGION="%R"
typeset -i DEBUG=0
typeset SSD_STANZA="SSD"
typeset LSD_STANZA="LSD"
typeset RD_STANZA="RD"
typeset CLSERVER_LIST=""
typeset CLS_NAME="clserver"
typeset LOG_MIGLOG="/var/cics_servers/LSD/.v12.miglog"
typeset SFS_MIGLOG="/var/cics_servers/SSD/.v12.miglog"
typeset SFSDIR="/var/cics_servers/SSD"
typeset SFS_LOGID="MigrateSFSServer"
typeset CLS_LOGID="MigrateCLServer"
typeset LOG_LOGID="MigrateRegionLog"
typeset DUMPLF_FAIL=1
typeset DUMPLF_PASS=2
typeset RESTORELF_FAIL=2
typeset RESTORELF_PASS=3
typeset CONVLOG1_FAIL=1
typeset CONVLOG1_PASS=2
typeset CONVLOG2_FAIL=2
typeset CONVLOG2_PASS=3
typeset SSDSTANZA="/var/cics_servers/SSD/AUTO.stanza"
typeset LSDSTANZA="/var/cics_servers/LSD/AUTO.stanza"
typeset RDSTANZA="/var/cics_regions/$ABBREV_REGION/database/RD/RD.$ABBREV_REGION/RD.auto"         


Debug()
{
    [ "$DEBUG" -eq 1 ] && echo $*
}


#------------------------------------------------------------------------
#
# SYNOPSIS: GeneralDispMsg MSN MSG_NO [parameters]
# DESCIPTION:
# Logs message
#
MigServMsg()
{
    typeset -r _MCATNAME="cics.cat" # message catalogue
    typeset _MSN                    # MSN is the first param
    typeset _MSNO                   # Message Number of the message
    typeset _DEFMSG                 # Default message text corresponding to
                                    # msg id

    _MSN=$1; shift                              # MSN
    _MSNO="`eval echo \\$${1}`"                 # MESSAGE ID
    _DEFMSG="`eval echo \\$${1}_TEXT`" ; shift  # DEFAULT MESSAGE TEXT

    ( dspmsg ${_MCATNAME} -s 46 ${_MSNO} "${_DEFMSG}" "$@" ; echo "" ) |
	    sed "s!ERZ[0-9]*[EWI]!&/$_MSN!" >&1
    ( dspmsg ${_MCATNAME} -s 46 ${_MSNO} "${_DEFMSG}" "$@" ; echo "" ) |
	    sed "s!ERZ[0-9]*[EWI]!&/$_MSN!" >&2

}


MigservProtStringToNumber()
{
  case $1 in
    default)     echo 0 ;;
    none)        echo 1 ;;
    connect)     echo 2 ;;
    call)        echo 3 ;;
    pkt)         echo 4 ;;
    pkt_integ)   echo 5 ;;
    pkt_privacy) echo 6 ;;
  esac
}


#
# this function changes all occurences of parameter 2 in parameter 1
# to paramater 3. For example, given the parameters log_%S,%S,SFS_SERV
# it will return log_SFS_SERV.  
#
SubStringInVal()
{
    NEWVAL=$1
    #
    # if parm 2 and parm3 are the same, there is nothing to do
    #
    if [[ $2 != $3 ]]
    then 
        #
        # make p1 everything up to the first $2 in $1
        #
        P1=${NEWVAL%%"$2"*}
        #
        # Each time around the loop substitutes the first $2 in 
        # $1, so keep going while removing the first $2 results
        # in a new string  
        #
        while [[ $NEWVAL != $P1 ]]
        do
            #
            # first take p1 and then $2 of the front of the string.
            # The new valus is then the concatenation of p1, $3, and 
            # what was left.
            #                                  
            REM=${NEWVAL#"$P1"}
            REM=${REM#"$2"}
            NEWVAL="$P1""$3""$REM"
            #
            # make P1 everything up to the first $2 in the updated
            # value.
            #
            P1=${NEWVAL%%"$2"*}
        done
    fi
    #
    # output the result
    #
    echo "$NEWVAL"
}

#
# This function retrieves a parameter value from a stanza file. It
# will currently read LSD, SSD and RD stanzas. It accpets the following
# inputs:
#   StanzaType:  SSD,LSD or RD
#   StanzaKey :  server name for SSD or LSD, region name for RD
#   Parameter :  name of parameter required.
# 
# Note: This script has been "knocked together" for migration and is
# not necessarily well desigend  
GetStanzaVal()
{
    #
    # define return codes
    #
    Parameter_Found=0
    Parameter_Not_Found=1
    ShortName_Not_Found=2
    Invalid_ShortName=3
    Server_Not_Found=4
    Stanza_Not_Readable=5

    #
    # Init ret code to Server_Not_Found
    #
    RetCode=$Server_Not_Found

    # Save the inputs in variables
    #
    GSV_stanza=$1
    GSV_key=$2
    GSV_param=$3 
    #
    # specify the stanza to read
    #
    case $GSV_stanza in
        "$SSD_STANZA")    STANZA_TO_READ="$SSDSTANZA" ;;
        "$LSD_STANZA")    STANZA_TO_READ="$LSDSTANZA" ;;
        "$RD_STANZA")     STANZA_TO_READ=$(SubStringInVal $RDSTANZA \
                                                          $ABBREV_REGION \
                                                          $GSV_key) ;;
        *)                STANZA_TO_READ="$SSDSTANZA" ;;
    esac 
    #
    # add execute premission to the stanza, just in case
    # it is not already there
    chmod +x "$STANZA_TO_READ"
    #
    # check the file exists, can be read and is executable
    #
    if [[ ! -r $STANZA_TO_READ || \
          ! -s $STANZA_TO_READ || \
          ! -x $STANZA_TO_READ ]]
    then
        MigServMsg $REGRM_MSNX_1 ERZ46206E $STANZA_TO_READ
        return $Stanza_Not_Readable
    fi

    #
    # set up the stanza as the input stream 
    #
    exec 8<&-
    exec 8< "$STANZA_TO_READ"
     
    shortnam=""
    paramval=""
    while read -u8 lineread && [[ $RetCode = $Server_Not_Found ]]
    do  
        # 
        # If we a serching an LSD or SSD stanza the right server
        # must be found before looking for the parameter.
        # 
        if [[ $GSV_stanza = "$SSD_STANZA" || $GSV_stanza = "$LSD_STANZA" ]]
        then
            #
            # Is this a line starting "/.;". If so it must be a
            # new server definition so see if it the one requested
            #
            if [[ ${lineread%%;*} = '/.' ]]
            then 
                #
                # change the input line to be the server name, so
                # take off the trailing : and cahnge the /.;/ to /.:/
                # 
                srvid=${lineread%%:*}
                srvid="/.:"${srvid#*;}
            
                #
                # if the server matches the input server set RetCode
                # to Parameter_Not_Found so that the next stage of the
                # search will beign. 
                #
                if [[ $srvid = $GSV_key ]]
                then 
                    #
                    # carry on reading through the Stanza until the parameter
                    # requested is found or the next server definition is
                    # reached
                    #
                    RetCode=$Parameter_Not_Found
                fi
            fi
        else
            #
            # The search is not through an LSD or SSD stanza so go straight
            # into the parameter search
            #
            RetCode=$Parameter_Not_Found
        fi

        if [ $RetCode = $Parameter_Not_Found ]
        then
            while read -u8 lineread && [[ $RetCode = $Parameter_Not_Found
                                            && ${lineread%%;*} != "/." ]] 
            do
                #
                # param name is everything before the "=" with the
                # leading blanks taken off
                #
                param=${lineread%%=*}
                param=${param%%" "*}
                param=${param##*" "}
                #
                # if param matches the one requested then retrieve it
                #
                if [[ $param = "$GSV_param" && $paramval = "" ]]
                then
                    #  
                    # the parameter value is everything after the
                    # "=" and the newline and quotes taken off
                    #
                    paramval=${lineread##*=}
                    paramval=`eval echo ${paramval%%/\n*}`
                    #
                    # if the value contains any "%S"'s they must
                    # be substituted with the ShortName  
                    if [[ $paramval != ${paramval##"$ABBREV_SHORTNAME"*}
                        ||$paramval != ${paramval%%"$ABBREV_SHORTNAME"*} ]]
                    then
                       if [[ $param = "$SD_SHORTNAME" ]]
                       then 
                          RetCode=$Invalid_Shortname
                       elif [[ $shortnam != "" ]]
                       then
                           paramval=$(SubStringInVal $paramval \
                                                     $ABBREV_SHORTNAME \
                                                     $shortnam) 
                           RetCode=$Parameter_Found
                       fi
                    else
                        RetCode=$Parameter_Found
                    fi
                    #
                    # if the value contains any "%H",s they must be
                    # sustitued with the Host name
                    #
                    if [[ $paramval != ${paramval##"$ABBREV_HOST"*}
                          ||$paramval != ${paramval%%"$ABBREV_HOST"*} ]]
                    then
                        hostid=$(uname -n)
                        paramval=$(SubStringInVal $paramval \
                                                  $ABBREV_HOST \
                                                  $hostid)
                    fi
                #
                # if this is the ShortName save it because the
                # parameter requested may be defined with a %S
                #
                elif [[ $param = "$SD_SHORTNAME" && $shortnam = "" ]]
                then
                     #
                     # Shortname is everything after the "=" and
                     # the newline and quotes taken off
                     #
                     shortnam=${lineread##*=}
                     shortnam=`eval echo ${shortnam%%\n*}`
                     if [[ $paramval != "" ]]
                     then
                         paramval=$(SubStringInVal $paramval %S $shortnam)
                         RetCode=$Parameter_Found
                     fi
                #
                # if param matches the one requested then retrieve it
                #
                fi 
            done 
        fi
    done
    exec 8<&-
    echo "$paramval"
    if [[ $RetCode = $Parameter_Not_Found && $paramval != "" ]]
    then
        RetCode=$ShortName_Not_Found
    fi
    return $RetCode
}

ListSFSServers()
{

    typeset RETCODE=2
    typeset SFS_SERVER_LIST=""
    typeset SFS_MIG_STRING="SFS Servers to migrate:"
    unset LINEREAD
    unset THISERVER

    #
    # if the migration log already exists see if it contains a lsit of
    # servers to migrate
    #
    if [[ -r $SFS_MIGLOG && -s $SFS_MIGLOG ]]
    then
        #
        # look for the line containing the server list               
        #
        SFS_SERVER_LIST=$(grep "$SFS_MIG_STRING" $SFS_MIGLOG | tail -1 2>&1)

        #
        # if the line existed, use the server lsit from it, if not the
        # Stanza will be serched
        #
        if [[ "$SFS_SERVER_LIST" != "" ]]
        then
            SFS_SERVER_LIST=${SFS_SERVER_LIST##*"$SFS_MIG_STRING "}
            if [[ "$SFS_SERVER_LIST" != "" ]]
            then
                RETCODE=0
            else 
                RETCODE=1
            fi
        fi
    fi
    
    #
    # either the migration log existed or it did not contain the 
    # server list, so get the list from ths SSD stanza
    #
    if [[ $RETCODE = 2 ]]
    then
        #
        # The server list must be extracted from the stanza.
        # add execute premission to the stanza, just in case
        # it is not already there
        chmod +x "$SSDSTANZA"

        #
        # check the file exists, can be read and is executable
        #
        if [[ ! -r $SSDSTANZA || \
              ! -s $SSDSTANZA || \
              ! -x $SSDSTANZA ]]
        then
            MigServMsg $REGRM_MSNX_2 ERZ46206E $SSDSTANZA
        else
            #
            # set up the stanza as the input stream
            #
            exec 8<&-
            exec 8< "$SSDSTANZA"

            while read -u8 LINEREAD 
            do
                #
                # Is this a line starting "/.;". If so it must be a
                # new server definition 
                #
                if [[ ${LINEREAD%%;*} = '/.' ]]
                then
                    #
                    # change the input line to be the server name, so
                    # take off the trailing :, change the /.;/ to /.:/
                    # and add it to the list
                    #
                    THISSERVER=${LINEREAD%%:*}
                    SFS_SERVER_LIST=$SFS_SERVER_LIST"/.:"${THISSERVER#*;}" "
                    RETCODE=0
                fi
            done
            #
            # write the list of servers that has been generated
            # to the migration log so that next time in there is
            # no need to read the stanza
            #
            echo "$SFS_MIG_STRING $SFS_SERVER_LIST" >>$SFS_MIGLOG
        fi
    fi
    echo $SFS_SERVER_LIST
    return $RETCODE
}

SFSMigLevel()
{
    unset SFSSERVID
    unset LOGLINE
    unset MIG_LEVEL
    unset MIG_PARMS

    SFSSERVID=$1
    #
    #  see if the log file exists 
    # 
    if [ -r $SFS_MIGLOG ]
    then
        #
        # see of any lines in the file relate to this server
        #
        OUTPUT=$(grep "$SFS_LOGID $SFSSERVID" $SFS_MIGLOG | wc -l 2>&1)
        if [ $OUTPUT -ne 0 ]
        then 
            #
            # There are lines relating to this server. Pick out the
            # last one. The first character shows the level of 
            # migration previously tried:
            #    1 - dump logfile failed
            #    2 - dump logfile succeeded, restore logfile failed 
            #    3 - restore logfile succeeded 
            # The rest after the server name is the info needed to 
            # complete the next level of migration.
            #
            LOGLINE=$(grep "$SFS_LOGID $SFSSERVID" $SFS_MIGLOG | tail -1 2>&1)
            MIG_LEVEL=${LOGLINE%%" "*} 
            MIG_PARMS=${LOGLINE##*"$SFS_LOGID $SFSSERVID "}
            echo "$MIG_PARMS"
        else
            MIG_LEVEL=0
        fi
    else 
        MIG_LEVEL=0
    fi     
    return $MIG_LEVEL
}

LogMigLevel()
{
    unset REGION_NAME
    unset LOGLINE
    unset MIG_LEVEL
    unset MIG_PARMS

    REGION_NAME=$1
    #
    #  see if the log file exists
    #
    if [ -r $LOG_MIGLOG ]
    then
        #
        # see of any lines in the file relate to this server
        #
        OUTPUT=$(grep "$LOG_LOGID $REGION_NAME" $LOG_MIGLOG | wc -l 2>&1)
        if [ $OUTPUT -ne 0 ]
        then
            #
            # There are lines relating to this region. Pick out the
            # last one. The first character shows the level of
            # migration previously tried:
            #    1 - convlog1  failed
            #    2 - convlog1 succeeded, convlog2 failed
            #    3 - convlog2 succeeded
            # The rest after the region name is the info needed to
            # complete the next level of migration.
            #
            LOGLINE=$(grep "$LOG_LOGID $REGION_NAME" $LOG_MIGLOG | tail -1 2>&1)
            MIG_LEVEL=${LOGLINE%%" "*}
            MIG_PARMS=${LOGLINE##*"$LOG_LOGID $REGION_NAME "}
            echo "$MIG_PARMS"
        else
            MIG_LEVEL=0
        fi
    else
        MIG_LEVEL=0
    fi
    return $MIG_LEVEL
}

StartClserver()
{
    Debug "StartClserver() Entry"
    #
    # Only input is serverid....so save it
    #   
    CLSERVID=$1
    Debug ">>> Log server Id is: $CLSERVID"
     
    #
    # Check to see if the server is already running 
    #
    OUTPUT=$($BINDIR/cicspingserver $CLSERVID 2>&1)
    if [ $? -eq 0 ] 
    then
        #
        # the server is already running, which is what the
        # caller wanted, so return. 
        Debug ">>> server already running"
        return 0
    fi

    #
    # If the migration log exists it may contain a record relating
    # to this server
    #
    OUTPUT=0
    if [ -r $SFS_MIGLOG ]
    then
        #
        # see of any lines in the file relate to this server
        #
        OUTPUT=$(grep "$CLS_LOGID $CLSERVID" $SFS_MIGLOG | wc -l 2>&1)
        if [ $OUTPUT -ne 0 ]
        then
            #
            # There are lines relating to this server. Pick out the
            # last one. 
            #
            LOGLINE=$(grep "$CLS_LOGID $CLSERVID" $SFS_MIGLOG | tail -1 2>&1) 

            #
            # Now extract the stanza fields that are needed from the 
            # line retrieved 
            #
            Debug ">>> Retrieve parms from migration log"
            MIG_PARMS=${LOGLINE##*"$CLSERVID "}
            CLSSHORTN=${MIG_PARMS%%" "*}
            Debug ">>> CLServer ShortName is $CLSSHORTN"
            MIG_PARMS=${MIG_PARMS#"$CLSSHORTN "}
            CLSUSERID=${MIG_PARMS%%" "*}
            Debug ">>> CLServer UserID is $CLSUSERID"
            MIG_PARMS=${MIG_PARMS#"$CLSUSERID "}
            CLSPROTLVLN=${MIG_PARMS%%" "*}
            Debug ">>> Protection level is $CLSPROTLVLN"
        fi
    fi
    
    # 
    # If the parms were no retrieved from the migration log, get
    # them from the stanza
    #
    if [[ ! -r $SFS_MIGLOG || $OUTPUT -eq 0 ]]
    then
        #
        # Get the Info we need from the LSD stanza
        #
        Debug ">>> Retrieve parms from the LSD Stanza"
        CLSUSERID=$(GetStanzaVal $LSD_STANZA $CLSERVID $SD_USERID)
        Get_Ret=$?
        if [ $Get_Ret -ne 0 ]
        then
            if [ $Get_Ret -eq 4 ]
            then
                MigServMsg $REGRM_MSNX_39 ERZ46232E $CLSERVID $LSDSTANZA
            else
                MigServMsg $REGRM_MSNX_3 ERZ46207E $SD_USERID $CLSERVID \
                            $LSDSTANZA 
            fi
            return 1
        fi
        Debug ">>> Server UserId is: $CLSUSERID"

        CLSSHORTN=$(GetStanzaVal $LSD_STANZA $CLSERVID $SD_SHORTNAME)
        if [[ $? != "0" ]]
        then
            MigServMsg $REGRM_MSNX_4 ERZ46207E $SD_SHORTNAME \ 
                        $CLSERVID $LSDSTANZA
            return 1
        fi
        Debug ">>> Server ShortName id: $CLSSHORTN"

        #
        # Get the protection level of the server and convert it to
        # a numeric value
        #
        CLSPROTLVL=$(GetStanzaVal $LSD_STANZA $CLSERVID $SD_PROTLEVEL)
        if [[ $? != "0" ]]
        then
            MigServMsg $REGRM_MSNX_5 ERZ46207E $SD_PROTLEVEL \
                        $CLSERVID $LSDSTANZA
            return 1
        fi
        CLSPROTLVLN=$(MigservProtStringToNumber $CLSPROTLVL)
        #
        # if ProtectionLevel is default(0) explicitly reset it
        # to pkt_integ(5)
        #
        [ "$CLSPROTLVLN" -eq 0  ] && CLSPROTLVLN=5
        Debug ">>> Protection Level is: $CLSPROTLVL:$CLSPROTLVLN"

        #
        # Write the server info to the migration log
        #
        PARM_STRING="$CLSUSERID $CLSSHORTN $CLSPROTLVLN"
        echo "$CLS_LOGID $CLSERVID $PARM_STRING" >>$SFS_MIGLOG
    fi

    #
    # strip the /.:/ off the front of the server id to get the principal id
    #
    CLSPRINID=${CLSERVID#"/.:/"}
    Debug ">>> Server principal is: $CLSPRINID"

    #
    # Get the home directory of the server's UserId                 
    #
    LOGSERVROOT=$(cicsname logserverdir)
    CLSHOME=${LOGSERVROOT}/${CLSPRINID}
    Debug ">>> Server home is:$CLSHOME:"
    
    #
    # Set the protection level
    #
    export ENCINA_AUTHN="$CLSPROTLVLN"
    [ "$ENCINA_AUTHN" -eq 1 ] && ENCINA_AUTHN=2
    export ENCINA_MIN_AUTHN="$ENCINA_AUTHN"

    #
    # Check the resart file exists, is not empty and is 
    # readable
    #  
    if [[ ! -r $CLSHOME/res || \
          ! -s $CLSHOME/res ]]
    then 
        MigServMsg $REGRM_MSNX_7 ERZ46209E $CLSHOME/res $CLSERVID
        return 1
    fi 

    #
    # read the restart string
    #
    RESTARTSTRING="'`cat $CLSHOME/res`'"
    Debug ">>> Restart String is: $RESTARTSTRING"
        
    #
    # change the command on the subsytem entry, but get
    # the shortname first.
    #
    SUBSYS_NAME="cicslog.$CLSSHORTN"

    #
    # check the subsytem exits and is ours
    #
    OUTPUT=$(lssrc -s $SUBSYS_NAME 2>&1)
    if [ $? -ne 0 ]
    then
        Debug ">>> $OUTPUT"
        MigServMsg $REGRM_MSNX_8 ERZ46210E $SUBSYS_NAME
        return 1
    fi

    #
    # Check we can run Clserver
    #
    CheckCanRun $CLS_NAME
    if [ $? -ne 0 ]
    then
        MigServMsg $REGRM_MSNX_61 ERZ46253E $CLS_NAME
        return 1
    fi
            
    #
    # change the old logserver subssytem entry to start the 
    # clserver
    #
    CLS_PATH=$(whence $CLS_NAME)
    OUTPUT=$(chssys -s $SUBSYS_NAME -p $CLS_PATH 2>&1)
    if [ $? -ne 0 ]
    then
        Debug ">>> $OUTPUT"
        MigServMsg $REGRM_MSNX_9 ERZ46211E $SUBSYS_NAME
        return 1
    fi

    #
    # set up the argumnets to startsrc
    #
    SUBSYS_NAME="cicslog.$CLSSHORTN"
    START_ARGS="-r $RESTARTSTRING -N $CLSPROTLVLN \
                -o cell_admin -p $CLSPRINID -k $CLSHOME/key"
    Debug ">>> Subsystem name is: $SUBSYS_NAME"
    Debug ">>> Start Args are: $START_ARGS"

    #
    # Now start the clserver
    #
    MigServMsg $REGRM_MSNX_10 ERZ46212I $CLSERVID
    OUTPUT=$(startsrc \
             -e "export NLSPATH=$NLSPATH" \
             -s cicslog.$CLSSHORTN -a "$START_ARGS")
    if [ $? -ne 0 ]
    then
        MigServMsg $REGRM_MSNX_11 ERZ46213E $CLSERVID $OUTPUT
        return 1
    fi
    echo "$OUTPUT" >&2
    echo "$OUTPUT"
    #
    # The server started so now wait for it to initialise
    # RUNNING can have several values
    #   0 - initial,
    #   1 - startsrc says server is active
    #   2 - startsrc says server is active, but cicspingerver
    #       says it is not listening yet.
    #   3 - server is listening for RPC's.
    RUNNING=0
    LSSRC_FAIL=0
    while [ $RUNNING -lt 3 ]
    do
        Debug ">>> RUNNING=$RUNNING"
        case $RUNNING in
        0)
            # Wait till lssrc says server is active
            LSSRC_FAIL=$LSSRC_FAIL+1
            LANG=C lssrc -s $SUBSYS_NAME | 
                       tail -1 | 
                       grep active 2>&1 >/dev/null && RUNNING=1
 
            #
            # if we have been waiting for lssrc for 7 loops and the
            # subsystem is still not active, just give up.
            #
            if [ $LSSRC_FAIL -eq 7 -a $RUNNING -eq 0 ]
            then
                RUNNING=99
            fi
            Debug ">>> After lssrc"
            ;;
        1|2)
            # Ping the server until it is listening
            OUTPUT=$($BINDIR/cicspingserver $CLSERVID 2>&1)

            case $? in
            0) RUNNING=3
               ;;
            1) #
               # Server not listening (yet). Make sure it 
               # is still active
               #
               RUNNING=2 
                LANG=C lssrc -s $SUBSYS_NAME |
                         tail -1 |
                         grep active 2>&1 >/dev/null || RUNNING=99

               ;;
            *) #
               # Had some DCE error. It could be that the logserver
               # has not yet exported its interface - make sure
               # SRC still thinks its Active
               #   

               Debug ">>> DCE error [$OUTPUT]"
               LANG=C lssrc -s $SUBSYS_NAME |
                         tail -1 |
                         grep active 2>&1 >/dev/null || RUNNING=99

               ;;
            esac
        esac
        #sleep for 15 seconds
        if [ $RUNNING -ne 3 ]
        then
            MigServMsg $REGRM_MSNX_13 ERZ46214I $CLSERVID
            sleep 10
        fi
    done
    if [ $RUNNING -eq 99 ]
    then
        #
        # server startup failed 
        # 
        MigServMsg $REGRM_MSNX_12 ERZ46254E $CLSERVID 
        #
        # make sure that the server is not running, before
        # returning.
        #
        OUTPUT=$(tkadmin stop server -server $CLSERVER 2>&1)
        return 1
    else
        #
        # server started OK, so note the fact
        #
        MigServMsg $REGRM_MSNX_14 ERZ46216I $CLSERVID
        #
        # Add the server to the list of servers started so that
        # StopCLservers() will stop it
        #
        CLSERVER_LIST="$CLSERVER_LIST $CLSERVID"
        return 0
    fi
}

StopCLservers()
{
    #
    # close the list of servers that was generate by StartCLServer
    #
    
    Debug "StopCLServers() Entry"
    Debug "Server list is $CLSERVER_LIST"
    if [[ "$CLSERVER_LIST" != "" ]]
    then
        for CLSERVER in $CLSERVER_LIST
        do
            Debug ">>> Stop server $CLSERVER"
            MigServMsg $REGRM_MSNX_15 ERZ46215I $CLSERVER
            OUTPUT=$(tkadmin stop server -server $CLSERVER 2>&1)
            Debug ">>> tkadmin ouput: $OUTPUT"
        done 
        CLSERVER_LIST=""
    fi
    #
    # Give the server chance to close down before exiting
    #
    sleep 5
    return 0
}

DumpSFSLog()
{
    Debug "DumpSFSLog() Entry"
    #
    # save the input parm...which should be the serverid
    #
    SFSSERVID=$1
    Debug ">>> DumpSFSLog serverid $SFSSERVID"

    MigServMsg $REGRM_MSNX_16 ERZ46217I $SFSSERVID
    #
    # See if the server has logile has previoulsy been dumped
    #
    OUTPUT=$(SFSMigLevel $SFSSERVID)
    MIG_LEVEL=$?
    Debug ">>> Migration level is $MIG_LEVEL"
    if [ $MIG_LEVEL -ge $DUMPLF_PASS ]
    then
        #
        # the logfile was previoulsy dumped successfully, so O/P a message
        # and return
        #
        MigServMsg $REGRM_MSNX_17 ERZ46218I $SFSSERVID
        return $DUMPLF_PASS
    elif [ $MIG_LEVEL -eq $DUMPLF_FAIL ]
    then
        #
        # we have previously tried to dump the log file so pick
        # up the stanza values from the output of MigSFSLevel
        # 
        Debug ">>> Get parms from migration log: $OUTPUT"
        SFSLOGFILE=${OUTPUT%%" "*}
        Debug ">>> Server Logfile is $SFSLOGFILE"
        OUTPUT=${OUTPUT#"$SFSLOGFILE "}
        SFSLOGSERVER=${OUTPUT%%" "*}
        Debug ">>> Server Logserver is $SFSLOGSERVER"
        OUTPUT=${OUTPUT#"$SFSLOGSERVER "}
        SFSUSERID=${OUTPUT%%" "*}
        Debug ">>> Server UserId is: $SFSUSERID"
        OUTPUT=${OUTPUT#"$SFSUSERID "}
        SFSLOGVOL=${OUTPUT%%" "*}
        Debug ">>> Server Log Volume is: $SFSLOGVOL"
    else
        #
        # Get the Info we need from the SSD stanza
        #
        Debug ">>> Get parms from stanza"
        SFSLOGFILE=$(GetStanzaVal $SSD_STANZA $SFSSERVID $SD_LOGFILE)
        Get_Ret=$?
        if [ $Get_Ret -ne 0 ] 
        then 
            if [ $Get_Ret -eq 4 ]
            then
                MigServMsg $REGRM_MSNX_18 ERZ46219E $SFSSERVID $SSDSTANZA
            else
                MigServMsg $REGRM_MSNX_19 ERZ46220E $SD_LOGFILE $SFSSERVID \
                            $SSDSTANZA
            fi
            return 1
        fi
        Debug ">>> Server Logfile is $SFSLOGFILE"

        SFSLOGSERVER=$(GetStanzaVal $SSD_STANZA $SFSSERVID $SD_LOGSERVER)
        if [ $? != "0" ]
        then
            MigServMsg $REGRM_MSNX_20 ERZ46220E $SD_LOGSERVER $SFSSERVID \
                        $SSDSTANZA
            return 1
        fi
        Debug ">>> Server Logserver is $SFSLOGSERVER"

        SFSUSERID=$(GetStanzaVal $SSD_STANZA $SFSSERVID $SD_USERID)
        if [ $? != "0" ]
        then
            MigServMsg $REGRM_MSNX_21 ERZ46220E $SD_USERID $SFSSERVID \
                        $SSDSTANZA
            return 1
        fi
        Debug ">>> Server UserId is: $SFSUSERID"

        SFSLOGVOL=$(GetStanzaVal $SSD_STANZA $SFSSERVID $SD_LOGVOLUME)
        if [ $? != "0" ]
        then
            MigServMsg $REGRM_MSNX_22 ERZ46220E $SD_LOGVOLUME $SFSSERVID \
                        $SSDSTANZA
            return 1
        fi
        SFSLOGVOL=$SFSLOGVOL
        Debug ">>> Server Log Volume is: $SFSLOGVOL"

    fi   

    #
    # strip the /.:/ off the front of the server id to get the 
    # principal id
    #
    SFSPRINID=${SFSSERVID#"/.:/"}
    Debug ">>> Server principal is: $SFSPRINID"

    #
    # Get the home directory of the server's UserId
    #
    SFSSERVROOT=$(cicsname sfsserverdir)
    SFSHOME=${SFSSERVROOT}/${SFSPRINID}
    Debug ">>> Server home is:$SFSHOME:"

    #
    # check that the server userid has read/write/execute premission for
    # the home directory
    #
    OUTPUT=$(ls -dl $SFSHOME | cut -c2-4 2>&1)
    if [[ $? -ne 0 || $OUTPUT != "rwx" ]]
    then
	MigServMsg $REGRM_MSNX_24 ERZ46221E $SFSHOME $SFSUSERID
	RETCODE=$DUMPLF_FAIL
    else
	#
	# check to see if the restart files already exist. If they
	# do, the migration of the SFS server has probably already
	# been done
	#
	if [ -s $SFSHOME/$SFS_RESTART1 -o \
	     -s $SFSHOME/$SFS_RESTART1.bak ]
	then
	    MigServMsg $REGRM_MSNX_25 ERZ46248W $SFSSERVID
	    #
	    # the restart files already exist so the customer may 
	    # have upgraded the server independantly. If so,
	    # we don't want to do anything else.
	    #
	    RETCODE=$DUMPLF_FAIL 
	else
	    #
	    #  Make sure the appropriate log server is running
	    #
	    StartClserver $SFSLOGSERVER
	    if [ $? -ne 0 ]
	    then
		MigServMsg $REGRM_MSNX_26 ERZ46222E $SFSLOGSERVER \
			    $SFSSERVID
		RETCODE=$DUMPLF_FAIL
	    else
		#
		# Now dump the logfile
		#
		rm -f $SFSDIR/dumplf.out
		rm -f $SFSDIR/$SFSUSERID.dumplf
		Debug ">>> dumplf -d $SFSHOME/$SFSLOGFILE.$SFS_DUMP_FTYPE \
				  -f $SFSLOGFILE -l $SFSLOGSERVER \
				  -v $SFSHOME/$SFS_RESTART1 \
				   >$SFSDIR/dumplf.out 2>&1"
		dumplf -d $SFSHOME/$SFSLOGFILE.$SFS_DUMP_FTYPE \
		       -f $SFSLOGFILE -l $SFSLOGSERVER \
		       -v $SFSHOME/$SFS_RESTART1 >$SFSDIR/dumplf.out 2>&1

		OUTPUT=$(grep 'Replica of the restart device'  \
			 $SFSDIR/dumplf.out | wc -l)
		if [ $OUTPUT -eq 0 ]
		then
		    rm -f $SFSHOME/$SFS_RESTART1 $SFSHOME/$SFS_RESTART1.bak
		    mv $SFSDIR/dumplf.out $SFSDIR/$SFSUSERID.dumplf
		    MigServMsg $REGRM_MSNX_27 ERZ46223E \
				$SFSHOME/$SFSLOGFILE.$SFS_DUMP_FTYPE \
				$SFSSERVID $SFSDIR/$SFSUSERID.dumplf
		    RETCODE=$DUMPLF_FAIL
		else
		    rm -f $SFSDIR/dumplf.out
		    MigServMsg $REGRM_MSNX_28 ERZ46247I $SFSSERVID
		    RETCODE=$DUMPLF_PASS
		fi
	    fi
	fi
    fi
    #
    # write the result to the migration log and return
    #
    PARM_STRING="$SFSLOGFILE $SFSLOGSERVER $SFSUSERID $SFSLOGVOL"
    echo "$RETCODE $SFS_LOGID $SFSSERVID $PARM_STRING" >>$SFS_MIGLOG
    return $RETCODE
}

RestoreSFSLog()
{

    Debug "RestoreSFSLogi() Entry"
    #
    # Only input is serverid....so save it
    #
    SFSSERVID=$1
    Debug ">>> Server Id is:$SFSSERVID:"

    MigServMsg $REGRM_MSNX_29 ERZ46224I $SFSSERVID
    typeset volRpcIface="8dbce948-702f-11ca-95ab-02608c2ed8ac/1/0"
    typeset OS_TYPE=`uname`

    #
    # See if the server has logile has previoulsy been restored
    #
    OUTPUT=$(SFSMigLevel $SFSSERVID)
    MIG_LEVEL=$?
    if [ $MIG_LEVEL -ge $RESTORELF_PASS ]
    then
        #
        # the logfile was previoulsy dumped successfully, so O/P a message
        # and return
        #
        MigServMsg $REGRM_MSNX_30 ERZ46225I $SFSSERVID
        return $RESTORELF_PASS
    else   
        #
        # we must have previously tried to dump the log file so pick
        # up the stanza values from the output of MigSFSLevel
        #
        Debug ">>> Get parms from migration log: $OUTPUT"
        SFSLOGFILE=${OUTPUT%%" "*}
        Debug ">>> Server Logfile is $SFSLOGFILE"
        OUTPUT=${OUTPUT#"$SFSLOGFILE "}
        SFSLOGSERVER=${OUTPUT%%" "*}
        Debug ">>> Server Logserver is $SFSLOGSERVER"
        OUTPUT=${OUTPUT#"$SFSLOGSERVER "}
        SFSUSERID=${OUTPUT%%" "*}
        Debug ">>> Server UserId is: $SFSUSERID"
        OUTPUT=${OUTPUT#"$SFSUSERID "}
        SFSLOGVOL=${OUTPUT%%" "*}
        Debug ">>> Server Log Volume is: $SFSLOGVOL"
    fi

    #
    # strip the /.:/ off the front of the server id to get the 
    # principal id
    #
    SFSPRINID=${SFSSERVID#"/.:/"}
    Debug ">>> Server principal is: $SFSPRINID"

    #
    # Get the home directory of the server's UserId
    #
    SFSSERVROOT=$(cicsname sfsserverdir)
    SFSHOME=${SFSSERVROOT}/${SFSPRINID}
    Debug ">>> Server home is:$SFSHOME:"

    #
    # check that the server userid has read/write/execute premission for
    # the home directory
    #
    OUTPUT=$(ls -dl $SFSHOME | cut -c2-4 2>&1)
    if [[ $? -ne 0 || $OUTPUT != "rwx" ]]
    then
        MigServMsg $REGRM_MSNX_32 ERZ46221E $SFSHOME $SFSUSERID
        return $RESTORELF_FAIL
    fi
  
    #
    # check the dump and restart files exist. These were created by
    # the DumpSFSLog routine and must exist for this stage to work
    #
    SFSDUMPFILE=$SFSHOME/$SFSLOGFILE.$SFS_DUMP_FTYPE
    if [[ ! -s $SFSDUMPFILE || \
          ! -s $SFSHOME/$SFS_RESTART1 || \
          ! -s $SFSHOME/$SFS_RESTART1.bak ]]
    then
        MigServMsg $REGRM_MSNX_33 ERZ46226E $SFSSERVID
        #
        # Migration will have to restart from the dump sfs log stage so
        # write a record to the migration log to make that happen
        PARM_STRING="$SFSLOGFILE $SFSLOGSERVER $SFSUSERID $SFSLOGVOL"
        echo "$DUMPLF_FAIL $SFS_LOGID $SFSSERVID $PARM_STRING" >>$SFS_MIGLOG
        return $RESTORELF_FAIL
    fi
    
    #
    # get the server identifier from the server id so that we can checl
    # the archive directory exists
    #
    SFSSERVIDENT=${SFSSERVID##*"/"}
    SFSARCHIVE=/var/cics_servers/archives/$SFSSERVIDENT
    Debug ">>> Archive directory is $SFSARCHIVE"
    if [[ ! -d $SFSARCHIVE ]]
    then
        mkdir -p $SFSARCHIVE
        if [ $? -ne 0 ]
        then
            MigServMsg $REGRM_MSNX_34 ERZ46227E $SFSARCHIVE $SFSSERVID
            return $RESTORELF_FAIL
        fi
    fi                                                   

    # 
    # make sure the archive directory has the correct permissions
    # 
    chown $SFSUSERID:cics $SFSARCHIVE 2>&1
    chmod 770 $SFSARCHIVE 2>&1 
    
    #
    # set the ENCINA_ADMIN_PRINCIPAL to cell_admin          
    #
    export ENCINA_ADMIN_PRINCIPAL="cell_admin"   

    #
    # make the SFS Server the ownner of the logical volumes
    #
    RAW_LOG_PATH=${CICS_SFS_LV_RAW_PATH}${SFSLOGVOL}
    BLOCK_LOG_PATH=${CICS_SFS_LV_BLOCK_PATH}${SFSLOGVOL}
    Debug ">>> chown $SFSUSERID:cics $RAW_LOG_PATH $BLOCK_LOG_PATH"
    OUTPUT=$(chown $SFSUSERID:cics $RAW_LOG_PATH $BLOCK_LOG_PATH 2>&1)

    #
    # Now begin the actual work of log file conversion.
    # First dump the logfile in a file system's file
    # Then start a volume server and define a logical volume as per user's
    # request.
    # Then re-create a 1.1 logfile and populate it.
    #
    MigServMsg $REGRM_MSNX_35 ERZ46228I $SFSSERVID

    #
    # start a volume server and define a logical volume
    #
    export ENCINA_TK_SERVER=$(cicsgetbindingstring $SFSSERVID) 
    rm -f $SFSDIR/$SFSUSERID.vol


    Debug ">>> Start the volserver"
    Debug ">>> volserver -w -v $SFSHOME/$SFS_RESTART1 -n $SFSSERVID \
          -p $SFSPRINID -k $SFSHOME/key >$SFSDIR/vol.out 2>&1 &"
    volserver -w -v $SFSHOME/$SFS_RESTART1 -n $SFSSERVID \
              -p $SFSPRINID -k $SFSHOME/key >$SFSDIR/vol.out 2>&1 &

    # wait for the volume server (3 min) to come up
    Debug ">>> Wait for volserver to start"
    volRpcIface="8dbce948-702f-11ca-95ab-02608c2ed8ac/1/0"
    Debug ">>> rpcutil waitfor 180 ${volRpcIface} ${ENCINA_TK_SERVER}"
    rpcutil waitfor 180 $volRpcIface ${ENCINA_TK_SERVER}
    if [ $? -ne 0 ]
    then
        mv $SFSDIR/vol.out $SFSDIR/$SFSUSERID.vol
        MigServMsg $REGRM_MSNX_37 ERZ46230E $SFSDIR/$SFSUSERID.vol
        return $RESTORELF_FAIL
    fi

    # create the encina logical volume
    rm -f $SFSDIR/tkadmin.out
    rm -f $SFSDIR/$SFSUSERID.tkadmin

    Debug ">>> map the log volume"
    Debug ">>> MapLVol $ENCINA_TK_SERVER $RAW_LOG_PATH 2>&1 \
               >$SFSDIR/tkadmin.out 2>&1"
    MapLVol $ENCINA_TK_SERVER $RAW_LOG_PATH 2>&1 >$SFSDIR/tkadmin.out 2>&1
    if [ $? -ne 0 ]  
    then
        rm -f $SFSDIR/vol.out
        mv $SFSDIR/tkadmin.out $SFSDIR/$SFSUSERID.tkadmin
        MigServMsg $REGRM_MSNX_38 ERZ46231E $SFSLOGVOL \
                   $SFSDIR/$SFSUSERID.tkadmin
        tkadmin stop server -server ${ENCINA_TK_SERVER} >/dev/null 2>&1
        return $RESTORELF_FAIL
    fi


    # shutdown the volume server
    Debug ">>> Stop the volserver"
    tkadmin stop server -server ${ENCINA_TK_SERVER} >/dev/null 2>&1
    rm -f $SFSDIR/tkadmin.out
    rm -f $SFSDIR/vol.out
    rm -f $SFSDIR/restore.out 
    rm -f $SFSDIR/$SFSUSERID.restore

    #
    # create the 1.1 logfile
    #
    Debug ">>> restorelf -d $SFSDUMPFILE \
              -l $SFSLOGVOL -v $SFSHOME/$SFS_RESTART1 \
              -c activeOpArchive -o $SFSARCHIVE >$SFSDIR/restore.out 2>&1"
    restorelf -d $SFSDUMPFILE \
              -l $SFSLOGVOL -v $SFSHOME/$SFS_RESTART1 \
              -c activeOpArchive -o $SFSARCHIVE >$SFSDIR/restore.out 2>&1

    OUTPUT=$(grep 'Number of log records written' $SFSDIR/restore.out | wc -l)
    if [ $OUTPUT -eq 0 ]
    then
        mv $SFSDIR/restore.out $SFSDIR/$SFSUSERID.restore
        MigServMsg $REGRM_MSNX_40 ERZ46233E $SFSSERVID \
                   $SFSDIR/$SFSUSERID.restore
        return $RESTORELF_FAIL
    fi
    rm -f $SFSDIR/restore.out
    MigServMsg $REGRM_MSNX_41 ERZ46234I $SFSSERVID

    #
    # now make sure that the restart files are owned by the server
    # and delete the dumpfile
    #
    OUTPUT=$(chown $SFSUSERID:cics $SFSHOME/$SFS_RESTART1 2>&1)                 
    OUTPUT=$(chown $SFSUSERID:cics $SFSHOME/$SFS_RESTART1.bak 2>&1)
    rm -f $SFSDUMPFILE
    #
    # Write a record to the Migration Log to say that the restore
    # has worked
    #
    PARM_STRING="$SFSLOGFILE $SFSLOGSERVER $SFSUSERID $SFSLOGVOL"
    echo "$RESTORELF_PASS $SFS_LOGID $SFSSERVID $PARM_STRING" >>$SFS_MIGLOG

    return $RESTORELF_PASS
}

DidSFSMigrateOK()
{
   Debug "Migrate105SFS() Entry"
   #
   # generate a list of servers to migrate
   #
   SFS_LIST=$(ListSFSServers)
   if [ $? -ne 0 ]
   then
       MigServMsg $REGRM_MSNX_53 ERZ46243I
   else
       Debug ">>> Server list is $SFS_LIST"
       #
       # Migrate each server in turn
       #
       for SFS_SERVER in $SFS_LIST
       do
           OUTPUT=$(SFSMigLevel $SFS_SERVER)
           if [ $? -ne RESTORELF_PASS ]
           then
               echo " "
               echo "WARNING: sfs server $SFS_SERVER migration failed. Correct"
               echo "         error noted earlier in this file and re-run SFS"
               echo "         server migration before restarting the server."
               echo " "
           fi
       done
   fi
}

Migrate105Log()
{ 
    Debug "Migrate105Log() Entry"
    #
    # input parm is region to migrate
    #
    REGION=$1
    Debug ">>> Region is $REGION"
    MigServMsg $REGRM_MSNX_42 ERZ46235I $REGION
    
    # Set up the Encina bin directory path for use later
    export PATH=$GETENCINAPATH:$PATH

    #
    # If the migration log file exists, get the stanza attributes
    # from it
    #
    MIG_PARMS=$(LogMigLevel $REGION)
    MIG_LEVEL=$?
    if [[ $MIG_LEVEL -ge $CONVLOG2_PASS ]]
    then
        #
        # the region log has previusoly been migrated, so O/P a message
        # and return
        #
        MigServMsg $REGRM_MSNX_62 ERZ46240I $REGION
        return $DUMPLF_PASS
    elif [[ $MIG_LEVEL -ge $CONVLOG1_FAIL ]]
    then
        Debug ">>> Get parms from migration log $MIG_PARMS"
        LOGSERVER=${MIG_PARMS%%" "*}
        Debug ">>> Region Logserver is $LOGSERVER"
        MIG_PARMS=${MIG_PARMS#"$LOGSERVER "}
        CLOGNAME=${MIG_PARMS%%" "*}
        Debug ">>> CLogName is $CLOGNAME"
        MIG_PARMS=${MIG_PARMS#"$CLOGNAME "}
        CARCHNAME=${MIG_PARMS%%" "*}
        Debug ">>> CArchName is: $CARCHNAME"
        MIG_PARMS=${MIG_PARMS#"$CARCHNAME "}
        LOGPROTECTION=${MIG_PARMS%%" "*}
        Debug ">>> LogProtection is: $LOGPROTECTION"
        LOG_PARMS="$LOGSERVER $CLOGNAME $CARCHNAME $LOGPROTECTION"
    else
        #
        # Get the attributes needed from the RD stanza
        #
        LOGSERVER=$(GetStanzaVal $RD_STANZA $REGION $RD_LOGSERVER)
        GET_RET=$?
        if [ $GET_RET -ne 0 ]
        then
            if [ $GET_RET -eq 5 ]
            then
                STANZAFILE=$(SubStringInVal $RDSTANZA $ABBREV_REGION $REGION)
                MigServMsg $REGRM_MSNX_43 ERZ46248E $STANZAFILE $REGION
            else
                STANZAFILE=$(SubStringInVal $RDSTANZA $ABBREV_REGION $REGION)
                MigServMsg $REGRM_MSNX_44 ERZ46236E $RD_LOGSERVER $REGION \
                            $STANZAFILE
            fi
            return 1
        fi
        Debug ">>> Region log server is $LOGSERVER"

        CLOGNAME=$(GetStanzaVal $RD_STANZA $REGION $RD_CLOGNAME)  
        if [ $? != "0" ]
        then
            STANZAFILE=$(SubStringInVal $RDSTANZA $ABBREV_REGION $REGION)
            MigServMsg $REGRM_MSNX_45 ERZ46236E $RD_CLOGNAME \
                        $REGION $STANZAFILE
            return 1
        fi
        Debug ">>> ClogName is: $CLOGNAME"

        CARCHNAME=$(GetStanzaVal $RD_STANZA $REGION $RD_CARCHNAME)  
        if [ $? != "0" ]
        then
            STANZAFILE=$(SubStringInVal $RDSTANZA $ABBREV_REGION $REGION)
            MigServMsg $REGRM_MSNX_46 ERZ46236E $RD_CARCHNAME $REGION \
                        $STANZAFILE
            return 1
        fi
        Debug ">>> CArchName is: $CARCHNAME"

        LOGPROTECTION=$(GetStanzaVal $RD_STANZA $REGION $RD_LOGPROTECTION)  
        if [ $? != "0" ]
        then
            STANZAFILE=$(SubStringInVal $RDSTANZA $ABBREV_REGION $REGION)
            MigServMsg $REGRM_MSNX_46 ERZ46236E $RD_LOGPROTECTION $REGION \
                        $STANZAFILE
            return 1
        fi
        Debug ">>> LogProtection is: $LOGPROTECTION"
        #
        # write the attributes to the migration log
        #
        LOG_PARMS="$LOGSERVER $CLOGNAME $CARCHNAME $LOGPROTECTION"
        echo "$CONVLOG1_FAIL $LOG_LOGID $REGION $LOG_PARMS" >>$LOG_MIGLOG
    fi

    #
    # If conversion stage 1 has not previously succeded, do it now
    #
    if [[ $MIG_LEVEL -lt $CONVLOG1_PASS ]] 
    then
        #   
        # Start the conversion log server
        #
        StartClserver $LOGSERVER
        if [ $? -ne 0 ]
        then
            MigServMsg $REGRM_MSNX_47 ERZ46237E $LOGSERVER $REGION
        else
            #
            # server started so convert the logfile
            # 
            MigServMsg $REGRM_MSNX_48 ERZ46238I $REGION
            Debug ">>> cicsmigratelog1 -r $REGION -m $LOGSERVER/$CLOGNAME -a $CARCHNAME -p $LOGPROTECTION"
            cicsmigratelog1 -r $REGION -m $LOGSERVER/$CLOGNAME -a $CARCHNAME -p $LOGPROTECTION
            MIGLOG_RET=$?
            if [ $MIGLOG_RET -eq 0 ]
            then
                #
                # first stage of conversion was successful so set
                # the migration level to indicate that
                #
                MigServMsg $REGRM_MSNX_49 ERZ46239I $REGION
                MIG_LEVEL=$CONVLOG1_PASS
            else
                MigServMsg $REGRM_MSNX_52 ERZ46242E $REGION \
                                      "${RC_ML1[$MIGLOG_RET]}"
            fi 
            #
            # Now stop the clserver
            #
            StopCLservers 
        fi
    fi
    #
    # if converision stage 1 has previously worked, do
    # stage 2.
    #
    if [[ $MIG_LEVEL -eq $CONVLOG1_PASS ]]
    then
        Debug ">>> cicsmigratelog2 -r $REGION"
        cicsmigratelog2 -r $REGION
        MIGLOG_RET=$?
        if [ $MIGLOG_RET -eq 0 ]
        then 
            #
            # second stage was successful so chown the files so that
            # they are owned by cics and delete the migration log
            #
            echo "$CONVLOG2_PASS $LOG_LOGID $REGION $LOG_PARMS" >>$LOG_MIGLOG
            OUTPUT=$(chown cics:cics /var/cics_regions/$REGION/log/* 2>&1)
            MigServMsg $REGRM_MSNX_50 ERZ46240I $REGION
        else
            echo "$CONVLOG2_FAIL $LOG_LOGID $REGION $LOG_PARMS" >>$LOG_MIGLOG
            MigServMsg $REGRM_MSNX_51 ERZ46241E $REGION \
                                      "${RC_ML2[$MIGLOG_RET]}"
        fi
    fi  
    return
}

Migrate105SFS()
{
   Debug "Migrate105SFS() Entry"
 
   # Set up the Encina bin directory path for use later
   export PATH=$GETENCINAPATH:$PATH

   #
   # generate a list of servers to migrate
   #
   SFS_LIST=$(ListSFSServers) 
   if [ $? -ne 0 ]
   then
       MigServMsg $REGRM_MSNX_53 ERZ46243I 
   else 
       Debug ">>> Server list is $SFS_LIST"
       #
       # Migrate each server in turn
       #
       for SFS_SERVER in $SFS_LIST
       do
           MigServMsg $REGRM_MSNX_54 ERZ46244I $SFS_SERVER
           #                                          
           # Dump the log volume
           #
           DumpSFSLog $SFS_SERVER 
           if [ $? -ne $DUMPLF_PASS ]
           then
               MigServMsg $REGRM_MSNX_55 ERZ46245E $SFS_SERVER
           else
               #
               # If the log volume dumped OK, restore the logfile
               #
               RestoreSFSLog $SFS_SERVER 
               if [ $? -eq $RESTORELF_FAIL ]
               then
               MigServMsg $REGRM_MSNX_56 ERZ46245E $SFS_SERVER
               else
               MigServMsg $REGRM_MSNX_57 ERZ46246I $SFS_SERVER
               fi
           fi    
       done
   fi
   # 
   #  Shutdown each of the logservers started.
   #
   StopCLservers
   #
   # put a warning of failed server migrations in the log
   #
   DidSFSMigrateOK
}
