/*
 *  NAME:    CICS PRAGMA substitution file - Data Packing ON
 *  VERSION: 1.1
 *  COPYRIGHT:                                                        
 *  
 *    (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
 *    (C) COPYRIGHT International Business Machines Corp. 1993, 1997
 *    All Rights Reserved
 *    Licensed Materials - Property of IBM
 *   
 *    US Government Users Restricted Rights - Use, duplication or
 *    disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *  
 *                                                                    
 *
 *  SYNOPSIS:
 *
 *  #include <cics_packon.h>
 *
 *  DESCRIPTION:
 *
 *  This file is provided to allow the use of PRAGMA statements
 *  within files used for different operating systems.
 *  In this case, the pragma turns on byte-packing of data for
 *  subsequent data definitions/declarations. This file should be
 *  included wherever the PRAGMA would itself have incorporated.
 *
 *  Note that a multiple inclusion defence is NOT appropriate for
 *  this header.
 */

#pragma	HP_ALIGN NOPADDING PUSH
