#!/bin/ksh
#
# NAME: cicsteld.sh
#
#
# VERSION:   1.1
#
# COPYRIGHT:                                                        
# 
#   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
#   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#  
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
#                                                                   
#
#
# SYNOPSIS:
#  cicsteld.sh [cicsteld parameters]
# DESCRIPTION:
#
#  This script sets nls environment and shared library path
#  variables and invokes the cics telnet demon cicsteld.
#  All parameters specified are passed through.
#
# CAVEATS/WARNINGS:
#
# The DCE messages file is included in the NLSPATH environment
# variable.  Check that the path matches the DCE installation on
# your machine.
#
# RELATED INFORMATION:
# See the documentation for cicsteld for information on parameters
# that can be passed to this script.
#
#*/
export LANG=C
export NLSPATH=/opt/cics/msg/%L/%N:/opt/dcelocal/nls/msg/%L/%N
export SHLIB_PATH=$SHLIB_PATH:/opt/dcelocal/lib:/opt/cics/lib
exec /opt/cics/bin/cicsteld $*

#
# Module what string
#
#@(#)supos,21:44:07,Apr 08 1998,s211-L980223
#
