-- 
-- NAME:	nxa1.db2
-- VERSION:	1.1
-- COPYRIGHT:                                                        
-- 
--   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
--   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
--   All Rights Reserved
--   Licensed Materials - Property of IBM
--  
--   US Government Users Restricted Rights - Use, duplication or
--   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-- 
-- 
--            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
-- 
-- INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
-- EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS"
-- WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
-- INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
-- MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
-- RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
-- BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
-- ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
-- IBM ) ASSUME 
-- THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
--                                                                   
-- 
-- This script should be run under db2 :  db2 -f nxa1.db2
--   It will create a database "cicstest" and within the database,
--   a table called cheese.
--   
create database cicstest authentication client with "cicstest database"
connect to cicstest
create table cheese \
  (name char(15) not null, \
   supplier char(30) not null, \
   supplier_address char(30) not null, \
   order_quantity integer not null)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('stilton', 'Northern Dairies', 'Richmond (Yorks)', 23)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('wensleydale', 'Northern Dairies', 'Richmond (Yorks)', 14)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('cheddar', 'Gorge Supplies', 'Wells (Somerset)', 10)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('brie', 'La Rochelle Importers', 'Dover (Kent)', 45)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('camembert', 'La Rochelle Importers', 'Dover (Kent)', 33)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('edam', 'East Anglian Distribution', 'Felixstowe (Suffolk)', 20)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('cheshire', 'Manchester Dairies', 'Manchester', 18)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('gouda', 'East Anglian Distribution', 'Felixstowe (Suffolk)', 29)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('red leicester', 'Midlands Dairies', 'Leicester (Leics)', 34)

insert into cheese (name, supplier, supplier_address, order_quantity) VALUES ('boursin', 'La Rochelle Importers', 'Dover (Kent)', 53)

grant all on cheese to public
grant connect on database to public 
connect reset
quit
