#
# NAME:         nxa1_db2.mk
# VERSION:      1.1
# COPYRIGHT:                                                        
# 
#   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
#   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#  
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
# 
#            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
# 
# INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
# EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS"
# WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
# INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
# RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
# BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
# ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
# IBM ) ASSUME 
# THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
#                                                                   
# 
#  NOTE : This Makefile assumes you have run db2ln - see
#         DATABASE 2 Installation Guide for more details

all: nxa1m.map nxa1

nxa1m.map: nxa1.bms
	cicsmap nxa1.bms

nxa1: nxa1.ccs
	CCFLAGS="-I/opt/IBMdb2/V2.1/include"; \
	export CCFLAGS; \
	LDFLAGS="-L/opt/IBMdb2/V2.1/lib -ldb2"; \
	export LDFLAGS; \
	cicstcl -e -d -lC nxa1.ccs

nxa1.ccs: nxa1.sqc
	db2 connect to cicstest; \
	db2 prep nxa1.sqc; \
	db2 grant execute on package nxa1 to public; \
	mv nxa1.c nxa1.ccs
