# 
# NAME:         nxa1_db2cob.mk
# VERSION:      1.1
# COPYRIGHT:                                                        
# 
#   (C) COPYRIGHT Hewlett Packard Company. 1993, 1997
#   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
#   All Rights Reserved
#   Licensed Materials - Property of IBM
#  
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
# 
#            NOTICE TO USERS OF THE SOURCE CODE EXAMPLES
# 
# INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THE SOURCE CODE
# EXAMPLES, BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, "AS IS"
# WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
# INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE
# RISK AS TO THE QUALITY AND PERFORMANCE OF THE SOURCE CODE EXAMPLES,
# BOTH INDIVIDUALLY AND AS ONE OR MORE GROUPS, IS WITH YOU.  SHOULD 
# ANY PART OF THE SOURCE CODE EXAMPLES PROVE DEFECTIVE, YOU (AND NOT 
# IBM ) ASSUME 
# THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
#                                                                   
# 

all: NXA1M.map nxa1.gnt

NXA1M.map: nxa1_db2cob.bms
	cicsmap nxa1_db2cob.bms

nxa1.gnt: nxa1.ccp
	COBCPY=/opt/cics/include:/opt/IBMdb2/V2.1/include/cobol_mf; \
	export COBCPY; \
	cicstcl -e -d -lCOBOL nxa1.ccp

nxa1.ccp: nxa1.sqb
	db2 connect to cicstest; \
	db2 prep nxa1.sqb; \
	db2 grant execute on package nxa1 to public; \
	mv nxa1.cbl nxa1.ccp
